package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFWorkListMapper;
import com.sa.ibiz.demo.demo.domain.WFWorkList;
import com.sa.ibiz.demo.demo.service.WFWorkListService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFWorkListSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WFInstanceService;
import com.sa.ibiz.demo.demo.service.WFUserService;

/**
 * 实体[WFWorkList] 服务对象接口实现
 */
@Service
public class WFWorkListServiceImpl extends ServiceImplBase<WFWorkListMapper, WFWorkList> implements WFWorkListService{

    @Autowired
    private WFInstanceService wfinstanceService;
    @Autowired
    private WFUserService originalwfuserService;

    @Resource
    private WFWorkListMapper wfworklistMapper;


    @Override
    public boolean create(WFWorkList et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WFWorkList et){
        this.beforeUpdate(et);
		this.wfworklistMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WFWorkList et){
		return et.getWfworklistid();  
    }

    @Override
    public boolean getDraft(WFWorkList et)  {
    if((!StringUtils.isEmpty(et.getWfinstanceid())) && et.getWfinstance() == null){
            try {
                et.setWfinstance(wfinstanceService.getById(et.getWfinstanceid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getOriginalwfuserid())) && et.getOriginalwfuser() == null){
            try {
                et.setOriginalwfuser(originalwfuserService.getById(et.getOriginalwfuserid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WFWorkList> listMyDB(WFWorkListSearchFilter filter) {
		return wfworklistMapper.searchMyDB(filter,filter.getSelectCond());
	}

	public Page<WFWorkList> searchMyDB(WFWorkListSearchFilter filter) {
		return wfworklistMapper.searchMyDB(filter.getPage(),filter,filter.getSelectCond());
	}


	public List<WFWorkList> listDefault(WFWorkListSearchFilter filter) {
		return wfworklistMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFWorkList> searchDefault(WFWorkListSearchFilter filter) {
		return wfworklistMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfworklistMapper.selectRow(sql);
    }

 }